package xl.model;

import xl.expr.Environment;
import xl.expr.Expr;

/**
 * A class representing a cell with an expression value.
 */
public class ExpressionCell implements Cell {
    private Expr expr;

    public ExpressionCell(Expr expr) {
        this.expr = expr;
    }

    public double cellValue(Environment env) {
        return expr.value(env);
    }

    public String displayValue() {
        return Double.toString(cellValue(ENVIRON));
    }

    public String formula() {
        return expr.toString();
    }
}


